﻿Public Class Form1

    Public Sub New()
        ' This call is required by the designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        RichTextBox1.AllowDrop = True
        AddHandler RichTextBox1.DragOver, AddressOf RichTextBox1_DragOver
        AddHandler RichTextBox1.DragDrop, AddressOf RichTextBox1_DragDrop
    End Sub


    Private Sub TreeView1_ItemDrag(sender As Object, e As ItemDragEventArgs) Handles TreeView1.ItemDrag
        TreeView1.DoDragDrop(e.Item, DragDropEffects.Copy)
    End Sub

    Private Sub RichTextBox1_DragOver(ByVal sender As Object, ByVal e As DragEventArgs)
        If e.Data.GetDataPresent(GetType(TreeNode)) Then
            e.Effect = DragDropEffects.Copy
        End If
    End Sub

    Private Sub RichTextBox1_DragDrop(ByVal sender As Object, ByVal e As DragEventArgs)
        If e.Data.GetDataPresent(GetType(TreeNode)) Then
            Dim node = DirectCast(e.Data.GetData(GetType(TreeNode)), TreeNode)
            RichTextBox1.AppendText(vbCrLf)
            RichTextBox1.SelectionColor = node.ForeColor
            RichTextBox1.SelectionBackColor = node.BackColor
            If node.NodeFont IsNot Nothing Then
                RichTextBox1.SelectionFont = node.NodeFont
            End If
            RichTextBox1.SelectedText = node.Text
        End If
    End Sub
End Class
